## quill 10.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...4.0)
project(quill)

#-------------------------------------------------------------------------------------------------------
# Options
#-------------------------------------------------------------------------------------------------------

option(QUILL_NO_EXCEPTIONS "Enable this option to build without exception handling support." OFF)

option(QUILL_NO_THREAD_NAME_SUPPORT "Enable this option to disable features that require thread name retrieval, ensuring compatibility with older Windows versions (e.g., Windows Server 2012/2016) and Android." OFF)

option(QUILL_X86ARCH "Enable x86-specific optimizations for cache coherence using _mm_prefetch, _mm_clflush, and _mm_clflushopt instructions. Ensure the target architecture must also be specified with -march=\"...\" when enabling this option." OFF)

option(QUILL_DISABLE_NON_PREFIXED_MACROS "Enable this option to disable non-prefixed `LOG_*` macros, keeping only the `QUILL_LOG_*` macros to avoid conflicts with other logging libraries." OFF)

option(QUILL_DISABLE_FUNCTION_NAME "Disable the use of __FUNCTION__ in `LOG_*` macros when the function name is not needed." OFF)

option(QUILL_DETAILED_FUNCTION_NAME "Use detailed function name (__PRETTY_FUNCTION__ or __FUNCSIG__) instead of __FUNCTION__ in LOG_* macros" OFF)

option(QUILL_DISABLE_FILE_INFO "Disable the use of __FILE__ and __LINE__ in `LOG_*` macros when the file name and the line number are not needed." OFF)

option(QUILL_ENABLE_ASSERTIONS "Enable assertions in release builds. When disabled, assertions are only active in debug builds." OFF)

option(QUILL_BUILD_EXAMPLES "Enable this option to build and install the examples. Set this to ON to include example projects in the build process and have them installed after configuring with CMake." OFF)

option(QUILL_BUILD_TESTS "Enable this option to build the test suite." OFF)

option(QUILL_ENABLE_EXTENSIVE_TESTS "Enable extensive tests that may require more resources and are not suitable for hosted CI runners." OFF)

option(QUILL_BUILD_BENCHMARKS "Enable this option to build the benchmarks." OFF)

option(QUILL_SANITIZE_ADDRESS "Enable AddressSanitizer (ASan) for memory error detection in tests." OFF)

option(QUILL_SANITIZE_THREAD "Enable ThreadSanitizer (TSan) for detecting thread-related issues in tests. Note: Using this option with non-Clang compilers may produce false positives." OFF)

option(QUILL_BUILD_FUZZING "Enable fuzzing with libFuzzer, AddressSanitizer, and UndefinedBehaviorSanitizer. Requires Clang compiler." OFF)

option(QUILL_CODE_COVERAGE "Enable code coverage analysis during the build." OFF)

option(QUILL_USE_VALGRIND "Use Valgrind as the default memory checking tool in CTest. Valgrind must be installed." OFF)

option(QUILL_ENABLE_INSTALL "Enable the CMake install target when Quill is not the master project." OFF)

option(QUILL_DOCS_GEN "Generate documentation during the build process." OFF)

# Internal option
set(QUILL_ENABLE_GCC_HARDENING OFF CACHE INTERNAL "")

#-------------------------------------------------------------------------------------------------------
# Determine if quill is built as a subproject (using add_subdirectory) or if it is the master project.
#-------------------------------------------------------------------------------------------------------
set(QUILL_MASTER_PROJECT FALSE CACHE BOOL "Master Project" FORCE)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(QUILL_MASTER_PROJECT TRUE CACHE BOOL "Master Project" FORCE)
endif ()

#-------------------------------------------------------------------------------------------------------
# Custom cmake functions
#-------------------------------------------------------------------------------------------------------
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include(QuillUtils)

#-------------------------------------------------------------------------------------------------------
# Resolve version
#-------------------------------------------------------------------------------------------------------
quill_extract_version()
project(quill VERSION ${QUILL_VERSION} LANGUAGES CXX)

#-------------------------------------------------------------------------------------------------------
# Set default build to release
#-------------------------------------------------------------------------------------------------------
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build" FORCE)
endif ()

#---------------------------------------------------------------------------------------
# Compiler config
#---------------------------------------------------------------------------------------
if (NOT CMAKE_CXX_STANDARD)
    # If CMAKE_CXX_STANDARD is not set, configure it to 17 by default
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
elseif (CMAKE_CXX_STANDARD LESS 17)
    # If CMAKE_CXX_STANDARD is set but less than 17, issue a fatal error
    message(FATAL_ERROR "Quill requires at least C++17. Please set CMAKE_CXX_STANDARD to 17 or higher.")
endif ()

#-------------------------------------------------------------------------------------------------------
# Required Packages
#-------------------------------------------------------------------------------------------------------
find_package(Threads REQUIRED)

if (QUILL_BUILD_TESTS)
    enable_testing()

    if (QUILL_USE_VALGRIND)
        # find valgrind
        find_program(MEMORYCHECK_COMMAND NAMES valgrind)
        if (NOT MEMORYCHECK_COMMAND)
            message(WARNING "Valgrind not found")
        endif ()

        # set valgrind params
        set(MEMORYCHECK_COMMAND_OPTIONS "--tool=memcheck --leak-check=full --leak-resolution=med --show-leak-kinds=all --track-origins=yes --vgdb=no --fair-sched=yes")

        # add memcheck test action to ctest
        include(CTest)
    endif ()
endif ()

# Error out if QUILL_ENABLE_EXTENSIVE_TESTS is ON but QUILL_BUILD_TESTS is OFF
if (QUILL_ENABLE_EXTENSIVE_TESTS AND NOT QUILL_BUILD_TESTS)
    message(FATAL_ERROR "QUILL_ENABLE_EXTENSIVE_TESTS requires QUILL_BUILD_TESTS to be enabled. Please enable QUILL_BUILD_TESTS.")
endif ()

#-------------------------------------------------------------------------------------------------------
# Log Info
#-------------------------------------------------------------------------------------------------------
if (QUILL_MASTER_PROJECT)
    option(QUILL_VERBOSE_MAKEFILE "Enable verbose output for makefiles when Quill is the master project. This provides detailed information about the build process." OFF)
    message(STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE})
    message(STATUS "QUILL_VERSION: ${QUILL_VERSION}")
endif ()

message(STATUS "QUILL_NO_EXCEPTIONS: " ${QUILL_NO_EXCEPTIONS})
message(STATUS "QUILL_NO_THREAD_NAME_SUPPORT: " ${QUILL_NO_THREAD_NAME_SUPPORT})
message(STATUS "QUILL_X86ARCH: " ${QUILL_X86ARCH})
message(STATUS "QUILL_DISABLE_NON_PREFIXED_MACROS: " ${QUILL_DISABLE_NON_PREFIXED_MACROS})
message(STATUS "QUILL_DISABLE_FUNCTION_NAME: " ${QUILL_DISABLE_FUNCTION_NAME})
message(STATUS "QUILL_DETAILED_FUNCTION_NAME: " ${QUILL_DETAILED_FUNCTION_NAME})
message(STATUS "QUILL_DISABLE_FILE_INFO: " ${QUILL_DISABLE_FILE_INFO})
message(STATUS "QUILL_ENABLE_ASSERTIONS: " ${QUILL_ENABLE_ASSERTIONS})
message(STATUS "QUILL_ENABLE_INSTALL: " ${QUILL_ENABLE_INSTALL})

#---------------------------------------------------------------------------------------
# Verbose make file option
#---------------------------------------------------------------------------------------
if (QUILL_VERBOSE_MAKEFILE)
    set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose output" FORCE)
endif ()

# address sanitizer flags
if (QUILL_SANITIZE_ADDRESS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address,undefined -fno-omit-frame-pointer -g")
endif ()

# thread sanitizer flags
if (QUILL_SANITIZE_THREAD)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer -g")
endif ()

# Append extra options for coverage
if (QUILL_CODE_COVERAGE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif ()

if (QUILL_BUILD_EXAMPLES)
    add_subdirectory(examples)
    add_subdirectory(docs/examples)
endif ()

if (QUILL_BUILD_BENCHMARKS)
    add_subdirectory(benchmarks)
endif ()

if (QUILL_BUILD_TESTS AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/test)
    add_subdirectory(test)
endif ()

if (QUILL_BUILD_FUZZING)
    if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        message(FATAL_ERROR "QUILL_BUILD_FUZZING requires Clang compiler")
    endif ()
    
    add_subdirectory(fuzz)
endif ()

# library name
set(TARGET_NAME quill)

# header files
set(HEADER_FILES
        include/quill/backend/BackendManager.h
        include/quill/backend/BackendOptions.h
        include/quill/backend/BackendWorker.h
        include/quill/backend/BackendWorkerLock.h
        include/quill/backend/BacktraceStorage.h
        include/quill/backend/ManualBackendWorker.h
        include/quill/backend/PatternFormatter.h
        include/quill/backend/RdtscClock.h
        include/quill/backend/SignalHandler.h
        include/quill/backend/StringFromTime.h
        include/quill/backend/ThreadUtilities.h
        include/quill/backend/TimestampFormatter.h
        include/quill/backend/TransitEvent.h
        include/quill/backend/TransitEventBuffer.h
        include/quill/backend/BackendUtilities.h

        include/quill/bundled/fmt/args.h
        include/quill/bundled/fmt/base.h
        include/quill/bundled/fmt/chrono.h
        include/quill/bundled/fmt/color.h
        include/quill/bundled/fmt/compile.h
        include/quill/bundled/fmt/format.h
        include/quill/bundled/fmt/format-inl.h
        include/quill/bundled/fmt/os.h
        include/quill/bundled/fmt/ostream.h
        include/quill/bundled/fmt/printf.h
        include/quill/bundled/fmt/ranges.h
        include/quill/bundled/fmt/std.h
        include/quill/bundled/fmt/xchar.h

        include/quill/core/Attributes.h
        include/quill/core/BoundedSPSCQueue.h
        include/quill/core/ChronoTimeUtils.h
        include/quill/core/Common.h
        include/quill/core/DynamicFormatArgStore.h
        include/quill/core/Codec.h
        include/quill/core/Filesystem.h
        include/quill/core/FrontendOptions.h
        include/quill/core/InlinedVector.h
        include/quill/core/LoggerBase.h
        include/quill/core/LoggerManager.h
        include/quill/core/LogLevel.h
        include/quill/core/MacroMetadata.h
        include/quill/core/MathUtilities.h
        include/quill/core/PatternFormatterOptions.h
        include/quill/core/QuillError.h
        include/quill/core/Rdtsc.h
        include/quill/core/SinkManager.h
        include/quill/core/SourceLocation.h
        include/quill/core/Spinlock.h
        include/quill/core/ThreadContextManager.h
        include/quill/core/TimeUtilities.h
        include/quill/core/UnboundedSPSCQueue.h
        include/quill/backend/Utf8Conv.h

        include/quill/filters/Filter.h

        include/quill/sinks/AndroidSink.h
        include/quill/sinks/ConsoleSink.h
        include/quill/sinks/FileSink.h
        include/quill/sinks/JsonSink.h
        include/quill/sinks/NullSink.h
        include/quill/sinks/RotatingFileSink.h
        include/quill/sinks/RotatingJsonFileSink.h
        include/quill/sinks/RotatingSink.h
        include/quill/sinks/Sink.h
        include/quill/sinks/StreamSink.h
        include/quill/sinks/SyslogSink.h
        include/quill/sinks/SystemdSink.h

        include/quill/std/Array.h
        include/quill/std/Chrono.h
        include/quill/std/Deque.h
        include/quill/std/FilesystemPath.h
        include/quill/std/ForwardList.h
        include/quill/std/List.h
        include/quill/std/Map.h
        include/quill/std/Optional.h

=== docs/CMakeLists.txt ===
find_package(Doxygen REQUIRED)

# Find all the public headers
set(QUILL_HEADER_DIR "${CMAKE_SOURCE_DIR}/include/quill")
file(GLOB_RECURSE QUILL_PUBLIC_HEADERS "${QUILL_HEADER_DIR}/*.h")

set(DOXYGEN_INPUT_DIR ${QUILL_HEADER_DIR})
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/xml/index.xml)
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

#Replace variables inside @@ with the current values
configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT_DIR}) #Doxygen won't create this for us
add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
        DEPENDS ${QUILL_PUBLIC_HEADERS}
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
        MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
        COMMENT "Generating docs")

add_custom_target(Doxygen ALL DEPENDS ${DOXYGEN_INDEX_FILE})

find_package(Sphinx REQUIRED)

set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)
set(SPHINX_INDEX_FILE ${SPHINX_BUILD}/index.html)

# Only regenerate Sphinx when:
# - Doxygen has rerun
# - Our doc files have been updated
# - The Sphinx config has been updated
add_custom_command(OUTPUT ${SPHINX_INDEX_FILE}
        COMMAND
        ${SPHINX_EXECUTABLE} -b html
        # Tell Breathe where to find the Doxygen output
        -Dbreathe_projects.Quill=${DOXYGEN_OUTPUT_DIR}/xml
        ${SPHINX_SOURCE} ${SPHINX_BUILD}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS
        # Other docs files you want to track should go here (or in some variable)
        ${CMAKE_CURRENT_SOURCE_DIR}/backend_options.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/backtrace_logging.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/basic_example.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/cheat_sheet.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/csv_writing.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/filters.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/formatters.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/frontend_options.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/index.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/installing.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/json_logging.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/log_levels.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/log_tagging.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/loggers.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/logging_macros.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/overview.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/quick_start.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/sink_types.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/sinks.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/timestamp_types.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/users-api.rst
        ${CMAKE_CURRENT_SOURCE_DIR}/wide_strings.rst
        ${DOXYGEN_INDEX_FILE}
        MAIN_DEPENDENCY ${SPHINX_SOURCE}/conf.py
        COMMENT "Generating documentation with Sphinx")

# Nice named target so we can run the job easily
add_custom_target(Sphinx ALL DEPENDS ${SPHINX_INDEX_FILE})

=== docs/requirements.txt ===
breathe
furo

=== examples/CMakeLists.txt ===
add_subdirectory(recommended_usage)
add_subdirectory(shared_library)

# Define a variable with all example targets
set(EXAMPLE_TARGETS
        quill_example_backend_thread_notify
        quill_example_backend_tsc_clock
        quill_example_backtrace_logging
        quill_example_binary_protocol_logging
        quill_example_bounded_dropping_queue_frontend
        quill_example_console_logging
        quill_example_console_logging_macro_free
        quill_example_custom_console_colours
        quill_example_rotating_file_logging
        quill_example_rotating_json_file_logging
        quill_example_rotating_json_file_logging_custom_json
        quill_example_signal_handler
        quill_example_sink_formatter_override
        quill_example_stopwatch
        quill_example_logger_removal_with_file_event_notifier
        quill_example_custom_frontend_options
        quill_example_file_logging
        quill_example_filter_logging
        quill_example_system_clock_logging
        quill_example_user_clock_source
        quill_example_user_defined_filter
        quill_example_user_defined_sink
        quill_example_tags_logging
        quill_example_json_console_logging
        quill_example_json_console_logging_custom_json
        quill_example_csv_writing
        quill_example_json_file_logging
        quill_example_user_defined_types_logging_custom_codec
        quill_example_user_defined_types_logging_deferred_format
        quill_example_user_defined_types_logging_direct_format
        quill_example_user_defined_types_logging_simple
)

# Add additional examples that are using exceptions in the example code
if (NOT QUILL_NO_EXCEPTIONS)
    add_subdirectory(sbe_binary_data)

    list(APPEND EXAMPLE_TARGETS quill_example_user_defined_types_multi_format)
endif ()

# Add example executables
foreach (example_target ${EXAMPLE_TARGETS})
    # Determine the source file from the target name
    string(REPLACE "quill_example_" "" source_name ${example_target})
    set(source_file "${source_name}.cpp")

    add_executable(${example_target} ${source_file})
    set_common_compile_options(${example_target})
    target_link_libraries(${example_target} quill)
endforeach ()

install(TARGETS ${EXAMPLE_TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== benchmarks/backend_throughput/CMakeLists.txt ===
add_executable(BENCHMARK_quill_backend_throughput quill_backend_throughput.cpp)
set_common_compile_options(BENCHMARK_quill_backend_throughput)
target_link_libraries(BENCHMARK_quill_backend_throughput quill)

add_executable(BENCHMARK_quill_backend_throughput_no_buffering quill_backend_throughput_no_buffering.cpp)
set_common_compile_options(BENCHMARK_quill_backend_throughput_no_buffering)
target_link_libraries(BENCHMARK_quill_backend_throughput_no_buffering quill)

=== benchmarks/compile_time/CMakeLists.txt ===
add_subdirectory(qwrapper)

add_executable(BENCHMARK_quill_compile_time compile_time_bench.cpp)
set_common_compile_options(BENCHMARK_quill_compile_time)
target_link_libraries(BENCHMARK_quill_compile_time qwrapper_compile_time_bench)

=== benchmarks/hot_path_latency/CMakeLists.txt ===
add_executable(BENCHMARK_quill_hot_path_rdtsc_clock hot_path_bench_config.h hot_path_bench.h quill_hot_path_rdtsc_clock.cpp)
set_common_compile_options(BENCHMARK_quill_hot_path_rdtsc_clock)
target_link_libraries(BENCHMARK_quill_hot_path_rdtsc_clock quill)

add_executable(BENCHMARK_quill_hot_path_system_clock hot_path_bench_config.h hot_path_bench.h quill_hot_path_system_clock.cpp)
set_common_compile_options(BENCHMARK_quill_hot_path_system_clock)
target_link_libraries(BENCHMARK_quill_hot_path_system_clock quill)

=== docs/examples/CMakeLists.txt ===
# Define a variable with all example targets
set(EXAMPLE_TARGETS
        quill_docs_binary_file_writer
        quill_docs_example_backend_options
        quill_docs_example_backtrace_logging_1
        quill_docs_example_backtrace_logging_2
        quill_docs_example_basic
        quill_docs_example_console
        quill_docs_example_csv_writer_1
        quill_docs_example_custom_format
        quill_docs_example_file
        quill_docs_example_filter_1
        quill_docs_example_json_logging
        quill_docs_example_loggers_remove
        quill_docs_example_multiple_sinks
        quill_docs_example_multiple_sinks_tags
        quill_docs_example_tags_with_custom_sink
        quill_docs_timestamp_types_1
)

# Add example executables
foreach (example_target ${EXAMPLE_TARGETS})
    # Determine the source file from the target name
    set(source_file "${example_target}.cpp")

    add_executable(${example_target} ${source_file})
    set_common_compile_options(${example_target})
    target_link_libraries(${example_target} quill)
endforeach ()

install(TARGETS ${EXAMPLE_TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/sbe_binary_data/CMakeLists.txt ===
set(EXAMPLE_TARGETS
        quill_example_sbe_logging
)

# Add example executables
foreach (example_target ${EXAMPLE_TARGETS})
    # Determine the source file from the target name
    string(REPLACE "quill_example_" "" source_name ${example_target})
    set(source_file "${source_name}.cpp")

    add_executable(${example_target} ${source_file})
    set_common_compile_options(${example_target})
    target_link_libraries(${example_target} quill)

    if (MSVC)
        target_compile_options(${example_target} PRIVATE /wd4245 /WX-)
    elseif (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
        target_compile_options(${example_target} PRIVATE -Wno-sign-conversion -Wno-error)
    endif ()

endforeach ()

install(TARGETS ${EXAMPLE_TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/shared_library/CMakeLists.txt ===
add_subdirectory(quill_shared_lib)

add_executable(quill_example_shared_lib example_shared.cpp)
set_common_compile_options(quill_example_shared_lib)
target_link_libraries(quill_example_shared_lib quill_shared_lib)

# Optional - apply visibility flag except for clang-cl
if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR
(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT CMAKE_CXX_COMPILER MATCHES "clang-cl"))
    target_compile_options(quill_example_shared_lib PRIVATE -fvisibility=hidden)
endif ()

# Required - Define QUILL_DLL_IMPORT when using the shared library on Windows
if (WIN32)
    target_compile_definitions(quill_example_shared_lib PRIVATE QUILL_DLL_IMPORT)

    # Post-build command to copy the DLL to the executable directory
    add_custom_command(TARGET quill_example_shared_lib POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
            $<TARGET_FILE:quill_shared_lib>   # DLL location
            $<TARGET_FILE_DIR:quill_example_shared_lib>)  # Executable directory

    # The below will always copy
    #    # Custom target to copy all DLLs to the executable directory
    #    add_custom_target(copy_dll ALL
    #            COMMAND ${CMAKE_COMMAND} -E copy
    #            $<TARGET_FILE:quill_shared_lib>          # DLL location
    #            $<TARGET_FILE_DIR:quill_example_shared_lib>  # Executable directory
    #            DEPENDS quill_shared_lib # Ensure all shared libs are built before copying
    #    )
    #
    #    # Ensure that the custom target is executed after quill_example_shared_lib is built
    #    add_dependencies(quill_example_shared_lib copy_dll)

endif ()

=== test/integration_tests/CMakeLists.txt ===
function(quill_add_test TEST_NAME SOURCES)
    set(HEADER_FILES
            ../bundled/doctest/doctest.h
            ../misc/TestUtilities.h
    )

    set(ADD_SOURCE_FILES
            ../misc/TestMain.cpp
            ../misc/TestUtilities.cpp
            ../misc/DocTestExtensions.cpp)

    list(APPEND SOURCES ${ADD_SOURCE_FILES})

    # Create a test executable
    add_executable(${TEST_NAME} "")

    set_common_compile_options(${TEST_NAME})

    # Add sources
    target_sources(${TEST_NAME} PRIVATE ${SOURCES} ${HEADER_FILES})

    # include dirs
    target_include_directories(${TEST_NAME}
            PUBLIC
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/test/misc>
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/test/bundled>
            $<INSTALL_INTERFACE:include>
            PRIVATE
            ..)

    # Link dependencies
    check_cxx_atomics_available(HAVE_CXX_ATOMIC)
    if (HAVE_CXX_ATOMIC)
        target_link_libraries(${TEST_NAME} quill)
    else()
        target_link_libraries(${TEST_NAME} quill atomic)
    endif()

    if (QUILL_ENABLE_EXTENSIVE_TESTS)
        target_compile_definitions(${TEST_NAME} PRIVATE QUILL_ENABLE_EXTENSIVE_TESTS)
    endif ()

    # Do not decay cxx standard if not specified
    set_property(TARGET ${TEST_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)

    # Set output test directory
    set_target_properties(${TEST_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/test)

    # Add this target to the post build unit tests
    doctest_discover_tests(${TEST_NAME})
endfunction()

include(Doctest)

quill_add_test(TEST_ArithmeticTypesLogging ArithmeticTypesLoggingTest.cpp)
quill_add_test(TEST_BackendExceptionNotifier BackendExceptionNotifierTest.cpp)
quill_add_test(TEST_BackendLongSleepAndNotify BackendLongSleepAndNotifyTest.cpp)
quill_add_test(TEST_BackendTransitBufferHardLimit BackendTransitBufferHardLimitTest.cpp)
quill_add_test(TEST_BackendTransitBufferSoftLimit BackendTransitBufferSoftLimitTest.cpp)
quill_add_test(TEST_BackendTscClock BackendTscClockTest.cpp)
quill_add_test(TEST_BacktraceDynamicLogLevel BacktraceDynamicLogLevelTest.cpp)
quill_add_test(TEST_BacktraceFlushOnError BacktraceFlushOnErrorTest.cpp)
quill_add_test(TEST_BacktraceManualFlush BacktraceManualFlushTest.cpp)
quill_add_test(TEST_BacktraceNoFlush BacktraceNoFlushTest.cpp)
quill_add_test(TEST_BacktraceTerminatedThreadFlush BacktraceTerminatedThreadFlushTest.cpp)
quill_add_test(TEST_BinaryDataLoggingTest BinaryDataLoggingTest.cpp)
quill_add_test(TEST_BinaryFileWriter BinaryFileWriterTest.cpp)
quill_add_test(TEST_BoundedBlockingQueue BoundedBlockingQueueTest.cpp)
quill_add_test(TEST_BoundedDroppingQueue BoundedDroppingQueueTest.cpp)
quill_add_test(TEST_CArrayTypesLogging CArrayTypesLoggingTest.cpp)
quill_add_test(TEST_BoundedDroppingQueueDropMessages BoundedDroppingQueueDropMessagesTest.cpp)
quill_add_test(TEST_ConsoleSinkStderrMultipleFormats ConsoleSinkStderrMultipleFormatsTest.cpp)
quill_add_test(TEST_ConsoleSinkStdoutMultipleFormats ConsoleSinkStdoutMultipleFormatsTest.cpp)
quill_add_test(TEST_CsvWriting CsvWritingTest.cpp)
quill_add_test(TEST_CsvWritingCustomFrontend CsvWritingCustomFrontendTest.cpp)
quill_add_test(TEST_EnumLogging EnumLoggingTest.cpp)
quill_add_test(TEST_FlushMultipleLoggers FlushMultipleLoggers.cpp)
quill_add_test(TEST_FlushWithoutAnyLog FlushWithoutAnyLog.cpp)
quill_add_test(TEST_JsonConsoleLogging JsonConsoleLoggingTest.cpp)
quill_add_test(TEST_JsonFileLogging JsonFileLoggingTest.cpp)
quill_add_test(TEST_JsonMultilineMetadata JsonMultilineMetadataTest.cpp)
quill_add_test(TEST_JsonVariedParamsLogging JsonVariedParamsLoggingTest.cpp)
quill_add_test(TEST_LogArgumentsEvaluation LogArgumentsEvaluationTest.cpp)
quill_add_test(TEST_LogFlushWithSoftLimit LogFlushWithSoftLimitTest.cpp)
quill_add_test(TEST_LoggerAddRemoveGet LoggerAddRemoveGetTest.cpp)
quill_add_test(TEST_MacroFreeBacktraceFlushTest MacroFreeBacktraceFlushTest.cpp)
quill_add_test(TEST_MacroFreeJsonLoggingTest MacroFreeJsonLoggingTest.cpp)
quill_add_test(TEST_MacroFreeMultiFrontendThreadsTest MacroFreeMultiFrontendThreadsTest.cpp)
quill_add_test(TEST_MacrosAndFunctionsLoggingTest MacrosAndFunctionsLoggingTest.cpp)
quill_add_test(TEST_MacrosDisableFileFunctionTest MacrosDisableFileFunctionTest.cpp)
quill_add_test(TEST_Macros MacrosTest.cpp)
quill_add_test(TEST_MultiFrontendThreads MultiFrontendThreadsTest.cpp)
quill_add_test(TEST_MultiFrontendThreadsTimestampOrderTest MultiFrontendThreadsTimestampOrderTest.cpp)
quill_add_test(TEST_MultilineMetadata MultilineMetadataTest.cpp)
quill_add_test(TEST_MultilineMetadataOverrideFormatTest MultilineMetadataOverrideFormatTest.cpp)
quill_add_test(TEST_MultipleSinksSameLogger MultipleSinksSameLoggerTest.cpp)
quill_add_test(TEST_OverrideSinkFormatter OverrideSinkFormatterTest.cpp)
quill_add_test(TEST_RemoveLoggerBlocking RemoveLoggerBlockingTest.cpp)
quill_add_test(TEST_RotatingSinkKeepOldest RotatingSinkKeepOldestTest.cpp)
quill_add_test(TEST_RotatingSinkOverwriteOldest RotatingSinkOverwriteOldestTest.cpp)
quill_add_test(TEST_RotatingSinkSizeRotation RotatingSinkSizeRotationTest.cpp)
quill_add_test(TEST_RuntimeMetadata RuntimeMetadataTest.cpp)
quill_add_test(TEST_ShrinkThreadLocalQueueTest ShrinkThreadLocalQueueTest.cpp)
quill_add_test(TEST_SignalHandler SignalHandlerTest.cpp)
quill_add_test(TEST_SignalHandlerLogger SignalHandlerLoggerTest.cpp)
quill_add_test(TEST_SingleFrontendThreadMultipleLoggers SingleFrontendThreadMultipleLoggersTest.cpp)
quill_add_test(TEST_SingleFrontendThread SingleFrontendThreadTest.cpp)
quill_add_test(TEST_SinkFilter SinkFilterTest.cpp)
quill_add_test(TEST_SinkFilterOverrideFormat SinkFilterOverrideFormatTest.cpp)
quill_add_test(TEST_StdArrayLogging StdArrayLoggingTest.cpp)
quill_add_test(TEST_StdChronoLogging StdChronoLoggingTest.cpp)
quill_add_test(TEST_StdDequeLogging StdDequeLoggingTest.cpp)
quill_add_test(TEST_StdFilesystemPathLogging StdFilesystemPathLoggingTest.cpp)
quill_add_test(TEST_StdForwardListLogging StdForwardListLoggingTest.cpp)
quill_add_test(TEST_StdListLogging StdListLoggingTest.cpp)
quill_add_test(TEST_StdMapLogging StdMapLoggingTest.cpp)
quill_add_test(TEST_StdMultiMapLogging StdMultiMapLoggingTest.cpp)
quill_add_test(TEST_StdMultiSetLogging StdMultiSetLoggingTest.cpp)
quill_add_test(TEST_StdOptionalLogging StdOptionalLoggingTest.cpp)
quill_add_test(TEST_StdPairLogging StdPairLoggingTest.cpp)
quill_add_test(TEST_StdSetLogging StdSetLoggingTest.cpp)
quill_add_test(TEST_StdTupleLogging StdTupleLoggingTest.cpp)
quill_add_test(TEST_StdUnorderedMapLogging StdUnorderedMapLoggingTest.cpp)
quill_add_test(TEST_StdUnorderedMultiMapLogging StdUnorderedMultiMapLoggingTest.cpp)
quill_add_test(TEST_StdUnorderedMultiSetLogging StdUnorderedMultiSetLoggingTest.cpp)
quill_add_test(TEST_StdUnorderedSetLogging StdUnorderedSetLoggingTest.cpp)
quill_add_test(TEST_StdVectorLogging StdVectorLoggingTest.cpp)
quill_add_test(TEST_SinkLogLevelFilter SinkLogLevelFilterTest.cpp)
quill_add_test(TEST_StartStopBackendWorker StartStopBackendWorkerTest.cpp)
quill_add_test(TEST_StringLargeLogging StringLargeLoggingTest.cpp)
quill_add_test(TEST_StringLoggingDynamicLogLevel StringLoggingDynamicLogLevelTest.cpp)
quill_add_test(TEST_StringLogging StringLoggingTest.cpp)
quill_add_test(TEST_StringRandomLargeLogging StringRandomLargeLoggingTest.cpp)
quill_add_test(TEST_StringRandomLogging StringRandomLoggingTest.cpp)
quill_add_test(TEST_StringRandomSmallLogging StringRandomSmallLoggingTest.cpp)
quill_add_test(TEST_StringRef StringRefTest.cpp)
quill_add_test(TEST_TagsLogging TagsLoggingTest.cpp)
quill_add_test(TEST_UnboundedUnlimitedQueue UnboundedUnlimitedQueueTest.cpp)
quill_add_test(TEST_UserClockSource UserClockSourceTest.cpp)
quill_add_test(TEST_UserDefinedTypeLoggingDeferredFormatTest UserDefinedTypeLoggingDeferredFormatTest.cpp)
quill_add_test(TEST_UserDefinedTypeLoggingDirectFormatTest UserDefinedTypeLoggingDirectFormatTest.cpp)
quill_add_test(TEST_UserDefinedTypeLogging UserDefinedTypeLoggingTest.cpp)
quill_add_test(TEST_UserSink UserSinkTest.cpp)
quill_add_test(TEST_VariableLogging VariableLoggingTest.cpp)

quill_add_test(TEST_CompileActiveLogLevel CompileActiveLogLevelTest.cpp)
target_compile_definitions(TEST_CompileActiveLogLevel PRIVATE -DQUILL_COMPILE_ACTIVE_LOG_LEVEL=QUILL_COMPILE_ACTIVE_LOG_LEVEL_WARNING)

if (WIN32)
    quill_add_test(TEST_WideStdTypesLogging WideStdTypesLoggingTest.cpp)
    quill_add_test(TEST_WideStringLogging WideStringLoggingTest.cpp)
endif ()

=== test/unit_tests/CMakeLists.txt ===
function(quill_add_test TEST_NAME SOURCES)
    set(HEADER_FILES
            ../bundled/doctest/doctest.h
            ../misc/TestUtilities.h
    )

    set(ADD_SOURCE_FILES
            ../misc/TestMain.cpp
            ../misc/TestUtilities.cpp
            ../misc/DocTestExtensions.cpp)

    list(APPEND SOURCES ${ADD_SOURCE_FILES})

    # Create a test executable
    add_executable(${TEST_NAME} "")

    set_common_compile_options(${TEST_NAME})

    if (NOT MSVC)
        # disable false warning on armel/armhf
        set_source_files_properties( PatternFormatterTest.cpp PROPERTIES
        COMPILE_FLAGS "-Wno-unused-value")
    endif()

    # Add sources
    target_sources(${TEST_NAME} PRIVATE ${SOURCES} ${HEADER_FILES})

    # include dirs
    target_include_directories(${TEST_NAME}
            PUBLIC
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/test/misc>
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/test/bundled>
            $<INSTALL_INTERFACE:include>
            PRIVATE
            ..)

    # Link dependencies
    target_link_libraries(${TEST_NAME} quill)

    # Do not decay cxx standard if not specified
    set_property(TARGET ${TEST_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)

    # Set output test directory
    set_target_properties(${TEST_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/test)

    # Add this target to the post build unit tests
    doctest_discover_tests(${TEST_NAME})
endfunction()

include(Doctest)

quill_add_test(TEST_BoundedQueueTest BoundedQueueTest.cpp)
quill_add_test(TEST_DynamicFormatArgStore DynamicFormatArgStoreTest.cpp)
quill_add_test(TEST_FileEventNotifier FileEventNotifierTest.cpp)
quill_add_test(TEST_FileSink FileSinkTest.cpp)
quill_add_test(TEST_FileUtilities FileUtilitiesTest.cpp)
quill_add_test(TEST_InlinedVector InlinedVectorTest.cpp)
quill_add_test(TEST_LoggerManager LoggerManagerTest.cpp)
quill_add_test(TEST_Logger LoggerTest.cpp)
quill_add_test(TEST_LogLevel LogLevelTest.cpp)
quill_add_test(TEST_MacroMetadata MacroMetadataTest.cpp)
quill_add_test(TEST_MathUtilities MathUtilitiesTest.cpp)
quill_add_test(TEST_PatternFormatter PatternFormatterTest.cpp)
quill_add_test(TEST_RotatingFileSink RotatingFileSinkTest.cpp)
quill_add_test(TEST_SinkManager SinkManagerTest.cpp)
quill_add_test(TEST_StringFromTime StringFromTimeTest.cpp)
quill_add_test(TEST_ThreadContextManager ThreadContextManagerTest.cpp)
quill_add_test(TEST_TimestampFormatter TimestampFormatterTest.cpp)
quill_add_test(TEST_TransitEventBuffer TransitEventBufferTest.cpp)
quill_add_test(TEST_UnboundedQueue UnboundedQueueTest.cpp)
quill_add_test(TEST_Utility UtilityTest.cpp)

if (NOT QUILL_USE_VALGRIND)
    quill_add_test(TEST_RdtscClock RdtscClockTest.cpp)
    quill_add_test(TEST_StopWatch StopWatchTest.cpp)
endif ()

=== debian/changelog ===
quill (10.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #1078353).
  * Remove doctest embedded source dependency.
  * Fix pattern formatter test source location prefix repo root path.
  * Updated d/watch file format to version 5.

 -- Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>  Wed, 29 Oct 2025 10:34:06 +0500

=== debian/control ===
Source: quill
Section: libs
Priority: optional
Maintainer: Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doctest-dev <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://github.com/odygrd/quill
Vcs-Browser: https://salsa.debian.org/syed/quill
Vcs-Git: https://salsa.debian.org/syed/quill.git

Package: quill-dev
Section: libdevel
Architecture: any
Depends:
	${misc:Depends},
Description: Asynchronous Low Latency C++ Logging Library
 Quill is a high-performance, header-only logging library for C++17 and
 onwards, specifically designed for low-latency applications. It provides
 asynchronous logging capabilities, making it suitable for real-time systems
 where minimal delay is critical. This package would be beneficial for
 developers working on performance-sensitive C++ applications.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

QUILL_BUILD_TESTS = "-DQUILL_BUILD_TESTS=OFF"
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	QUILL_BUILD_TESTS = "-DQUILL_BUILD_TESTS=ON"
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	$(QUILL_BUILD_TESTS)

=== debian/watch ===
Version: 5
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

Template: Github
Owner: odygrd
Project: quill

## quill 11.0.1

=== benchmarks/CMakeLists.txt ===
add_subdirectory(hot_path_latency)
add_subdirectory(backend_throughput)
add_subdirectory(compile_time)

=== fuzz/CMakeLists.txt ===
function(quill_add_fuzzer FUZZER_NAME SOURCES)
    # Create fuzzer executable
    add_executable(${FUZZER_NAME} "")
    set_common_compile_options(${FUZZER_NAME})
    target_sources(${FUZZER_NAME} PRIVATE ${SOURCES})
    target_link_libraries(${FUZZER_NAME} quill)
    target_compile_options(${FUZZER_NAME} PRIVATE
            -fsanitize=fuzzer,address,undefined
            -fno-omit-frame-pointer
            -g
    )
    target_link_options(${FUZZER_NAME} PRIVATE
            -fsanitize=fuzzer,address,undefined
    )
    set_property(TARGET ${FUZZER_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
    set_target_properties(${FUZZER_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/test)
endfunction()

quill_add_fuzzer(FUZZ_BasicTypes BasicTypesFuzzer.cpp)
quill_add_fuzzer(FUZZ_StlContainers StlContainersFuzzer.cpp)
quill_add_fuzzer(FUZZ_UserDefinedDeferredFormat UserDefinedDeferredFormatFuzzer.cpp)
quill_add_fuzzer(FUZZ_UserDefinedDirectFormat UserDefinedDirectFormatFuzzer.cpp)
quill_add_fuzzer(FUZZ_QueueStress QueueStressFuzzer.cpp)
quill_add_fuzzer(FUZZ_BinaryData BinaryDataFuzzer.cpp)

=== test/CMakeLists.txt ===
add_subdirectory(unit_tests)
add_subdirectory(integration_tests)

=== docs/examples/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
         quill_docs_example_multiple_sinks
         quill_docs_example_multiple_sinks_tags
         quill_docs_example_tags_with_custom_sink
+        quill_docs_quick_start
         quill_docs_timestamp_types_1
 )

=== examples/recommended_usage/CMakeLists.txt ===
add_subdirectory(quill_static_lib)

set(EXAMPLE_TARGETS
        quill_example_recommended_usage
        quill_example_std_types_logging
        quill_example_use_overwrite_macros
)

# Add example executables
foreach (example_target ${EXAMPLE_TARGETS})
    # Determine the source file from the target name
    string(REPLACE "quill_example_" "" source_name ${example_target})
    set(source_file "${source_name}.cpp")

    add_executable(${example_target} ${source_file})
    set_common_compile_options(${example_target})
    target_link_libraries(${example_target} quill_static_lib_recommended_usage)
endforeach ()

install(TARGETS ${EXAMPLE_TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== test/integration_tests/CMakeLists.txt ===
--- 
+++ 
@@ -60,6 +60,7 @@
 quill_add_test(TEST_BackendTscClock BackendTscClockTest.cpp)
 quill_add_test(TEST_BacktraceDynamicLogLevel BacktraceDynamicLogLevelTest.cpp)
 quill_add_test(TEST_BacktraceFlushOnError BacktraceFlushOnErrorTest.cpp)
+quill_add_test(TEST_BacktraceMultithreadedStressTest BacktraceMultithreadedStressTest.cpp)
 quill_add_test(TEST_BacktraceManualFlush BacktraceManualFlushTest.cpp)
 quill_add_test(TEST_BacktraceNoFlush BacktraceNoFlushTest.cpp)
 quill_add_test(TEST_BacktraceTerminatedThreadFlush BacktraceTerminatedThreadFlushTest.cpp)
@@ -138,6 +139,7 @@
 quill_add_test(TEST_UnboundedUnlimitedQueue UnboundedUnlimitedQueueTest.cpp)
 quill_add_test(TEST_UserClockSource UserClockSourceTest.cpp)
 quill_add_test(TEST_UserDefinedTypeLoggingDeferredFormatTest UserDefinedTypeLoggingDeferredFormatTest.cpp)
+quill_add_test(TEST_UserDefinedTypeDeferredFormatCopyMove UserDefinedTypeDeferredFormatCopyMoveTest.cpp)
 quill_add_test(TEST_UserDefinedTypeLoggingDirectFormatTest UserDefinedTypeLoggingDirectFormatTest.cpp)
 quill_add_test(TEST_UserDefinedTypeLogging UserDefinedTypeLoggingTest.cpp)
 quill_add_test(TEST_UserSink UserSinkTest.cpp)

=== benchmarks/compile_time/qwrapper/CMakeLists.txt ===
set(LIB_NAME qwrapper_compile_time_bench)

add_library(${LIB_NAME} STATIC
        include/qwrapper/qwrapper.h
        include/qwrapper/qwrapper.cpp)

# Add include directories for this library
target_include_directories(${LIB_NAME}
        PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
        PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR})

# Link quill dependency
target_link_libraries(${LIB_NAME} PUBLIC quill::quill)

=== examples/recommended_usage/quill_static_lib/CMakeLists.txt ===
set(LIB_NAME quill_static_lib_recommended_usage)

add_library(${LIB_NAME} STATIC
        overwrite_macros.h
        quill_static.h
        quill_static.cpp)

# Add include directories for this library
target_include_directories(${LIB_NAME}
        PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

set_common_compile_options(${LIB_NAME})

# Link quill dependency
target_link_libraries(${LIB_NAME} PUBLIC quill::quill)

=== examples/shared_library/quill_shared_lib/CMakeLists.txt ===
set(LIB_NAME quill_shared_lib)

add_library(${LIB_NAME} SHARED
        quill_shared.h
        quill_shared.cpp)

# Add include directories for this library
target_include_directories(${LIB_NAME}
        PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

set_common_compile_options(${LIB_NAME})

# Optional - Set the compiler flags for GCC/Clang
if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR
(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT CMAKE_CXX_COMPILER MATCHES "clang-cl"))
    target_compile_options(${LIB_NAME} PRIVATE -fvisibility=hidden)
endif ()

# Required - Define QUILL_DLL_EXPORT when building the library on Windows
if (WIN32)
    target_compile_definitions(${LIB_NAME} PRIVATE QUILL_DLL_EXPORT)
endif ()

# Link quill dependency
target_link_libraries(${LIB_NAME} PUBLIC quill::quill)

=== debian/changelog ===
quill (11.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #1078353).
  * Remove doctest embedded source dependency.
  * Fix pattern formatter test source location prefix repo root path.
  * Updated d/watch file format to version 5.

 -- Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>  Sun, 7 Dec 2025 01:34:06 +0500

=== debian/tests/control ===
Tests: upstream-tests
Depends: @, build-essential, cmake, doctest-dev
